/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_config.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *		vZbTˑW[iSH34pj
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  CPUbNtÔ߂̕ϐ
 */
volatile bool_t		lock_flag;		/* CPUbNtO̒lێϐ */
volatile uint8_t	saved_iipm;		/* ݗDx}XNۑϐ */

/*
 *  eݔԍIPȐǗe[u
 *  e̒`́CvZbT^ԖɈقȂ̂߁C
 *  vZbT^Ԗ̒`t@CŒ`
 */
const IPR_INFO ipr_info_tbl[TNUM_INH] = {
    IPR_INFO_TBL_DATA 
};

/*
 *  xN^[x[X̕ۑ
 */
static void *saved_vbr;

/*
 *  J[l̃xN^[x[X
 */
extern void base_vec(void);

/*
 *  vZbTˑ̏
 */
void
prc_initialize(void)
{
    /*
     *  CPUbNtÔ߂̕ϐ̏
     */
    lock_flag = true;
    saved_iipm = IIPM_ENAALL;
    
    /*
     *  ݃Rg[̏
     *  vZbTɒ` 
     */
    init_irc();

    /*
     *  xN^[x[XWX^̏
     */
    saved_vbr = current_vbr();
    set_vbr(base_vec);
}

/*
 *  vZbTˑ̏I
 */
void
prc_terminate(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookւ̃|C^CUvolatileŵfpɑ
     *  Ăĝ́C0Ƃ̔rœKō폜Ȃ悤ɂ邽
     *  ߂łD
     */
    if (fp != 0) {
        (*fp)();
    }

    set_vbr(saved_vbr);
}

/*
 *  ݗvC̐ݒ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO_CFGINT(intno));
    assert(-15 <= intpri && intpri <= TMAX_INTPRI);

    /* 
     *  U݂֎~
     */    
    (void)x_disable_int(intno);

#ifndef SH4
    /*
     *  xgK/GbWgK̐ݒ
     *  IRQ̂݃T|[g
     */
    if(INTNO_IRQ(intno) != 0U){
        uint16_t icr1_val = sil_rew_mem((void*)ICR1);
        uint16_t offset   = INTNO_IRQ_OFFSET(intno) * 2U;

        icr1_val &=  ~(0x03U << offset);
        
        if((intatr & TA_POSEDGE) != 0U) {
            /*
             *  |WeBuGbW
             */
            icr1_val |= IRQ_POSEDGE << offset;            
        }else if((intatr & TA_NEGEDGE) != 0U) {
            /*
             *  lKeBuGbW
             */
            icr1_val |= IRQ_NEGEDGE << offset;                        
        }else {
            /*
             *  [xgK
             */
            icr1_val |= IRQ_LOWLEVEL << offset;
        }
        
        sil_wrw_mem((void*)ICR1, icr1_val);
    }
#endif /* SH4 */

    /*
     *  ݗv}XN(Kvȏꍇ)
     *  ɊݗDxZbg
     */
    if ((intatr & TA_ENAINT) != 0U) {
        (void) x_enable_int(intno);
    }    
}


#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *  TrapaȊO̗Oœo^ĂȂOƌĂяo
 */
void
default_exc_handler(void *p_excinf)
{
    uint32_t expevt = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_EXPEVT);
    uint32_t spc    = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_SPC);
    uint32_t ssr    = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_SSR);
    uint32_t pr     = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_PR);
    
    syslog(LOG_EMERG, "Unregistered Expevt error occurs.");
    syslog(LOG_EMERG, "Expevt = %08x SPC = %08x SR = %08x PR=%08X",
           expevt, spc, ssr, pr);
    target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  o^݂̊ꍇɌĂяo
 */
void
default_int_handler(void *p_excinf)
{
    uint32_t spc     = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_SPC);
    uint32_t ssr     = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_SSR);
    uint32_t pr      = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_PR);
    uint32_t intevt  = sil_rew_mem((void*)INTEVT);
#ifdef USE_INTEVT2    
    uint32_t intevt2 = sil_rew_mem((void*)INTEVT2);
#endif /* USE_INTEVT2 */      
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
#ifdef USE_INTEVT2    
    syslog(LOG_EMERG, "INTEVT = %08x INTEVT2 = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, intevt2, spc, ssr, pr);
#else
    syslog(LOG_EMERG, "INTEVT = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, spc, ssr, pr);    
#endif /* USE_INTEVT2 */      
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
