/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_timer.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *  ^C}hCoiSH34pj
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
#ifdef TRACE_ENABLE
#endif /* TRACE_ENABLE */

/*
 *  ^C}̋N
 */
void
target_timer_initialize(intptr_t exinf)
{
    CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

    /*
     *  ^C}ݒ肵C^C}̓JnD
     */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR0));  /* ^C}~ */
    assert(cyc <= MAX_CLOCK);             /* ^C}l̃`FbN */

    /* ݒA荞݋ */
    sil_wrh_mem((void*)TMU_TCR0,(TCR_UNIE | TCR0_TPSC));
    
    sil_wrw_mem((void*)TMU_TCOR0, cyc); /* timer constantWX^Zbg */
    sil_wrw_mem((void*)TMU_TCNT0, cyc); /* JE^[Zbg */

    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR0,
                (sil_reh_mem((void*)TMU_TCR0) & ~TCR_UNF));

    /* ^C}0X^[g */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) | TMU_STR0));
}

/*
 *  ^C}̒~
 */
void
target_timer_terminate(intptr_t exinf)
{
    /* ^C}~ */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR0));
    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR0,0);
}

/*
 *  ^C}݃nh
 */
void
target_timer_handler(void)
{
    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR0,
                (sil_reh_mem((void*)TMU_TCR0) & ~TCR_UNF));
      
    i_begin_int(INTNO_TIMER);
    signal_time();                    /* ^CeBbN̋ */
    i_end_int(INTNO_TIMER);
}
