/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  $Id: kernel.h 623 2012-05-13 03:41:36Z ertl-hiro $
 */

/*
 *		TOPPERS/HRPJ[l Wwb_t@C
 *
 *  TOPPERS/HRPJ[lT|[gT[rXR[̐錾ƁCKvȃf[
 *  ^^C萔C}N̒`܂ރwb_t@CD
 *
 *  AZũ\[Xt@C炱̃t@CCN[h鎞
 *  ́CTOPPERS_MACRO_ONLY`ĂDɂC}N`ȊO
 *  悤ɂȂĂD
 *
 *  ̃t@CCN[hOɃCN[hĂׂt@C
 *  ͂ȂD
 */

#ifndef TOPPERS_KERNEL_H
#define TOPPERS_KERNEL_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *	TOPPERSʂ̃f[^^E萔E}N
 */
#include <t_stddef.h>

/*
 *  ^[Qbgˑ
 */
#include "target_kernel.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  f[^^̒`
 */

/*
 *  rbgp^[IuWFNgԍ̌^`
 */
typedef	uint_t		TEXPTN;		/* ^XNOṽrbgp^[ */
typedef	uint_t		FLGPTN;		/* CxgtÕrbgp^[ */
typedef	ulong_t		OVRTIM;		/* vZbT */
typedef	uint_t		INTNO;		/* ݔԍ */
typedef	uint_t		INHNO;		/* ݃nhԍ */
typedef	uint_t		EXCNO;		/* CPUOnhԍ */

/*
 *  Pʂ̌^`
 */
typedef void	(*TASK)(intptr_t exinf);
typedef void	(*TEXRTN)(TEXPTN texptn, intptr_t exinf);
typedef void	(*CYCHDR)(intptr_t exinf);
typedef void	(*ALMHDR)(intptr_t exinf);
typedef void	(*OVRHDR)(ID tskid, intptr_t exinf);
typedef void	(*ISR)(intptr_t exinf);
typedef void	(*INTHDR)(void);
typedef void	(*EXCHDR)(void *p_excinf);
typedef ER_UINT	(*EXTSVC)(intptr_t par1, intptr_t par2, intptr_t par3,
								intptr_t par4, intptr_t par5, ID cdmid);
typedef void	(*INIRTN)(intptr_t exinf);
typedef void	(*TERRTN)(intptr_t exinf);

/*
 *  ̈mۂ̂߂̌^`
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	intptr_t
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T	STK_T;	/* X^bN̈mۂ邽߂̌^ */

#ifndef TOPPERS_MPF_T
#define TOPPERS_MPF_T	intptr_t
#endif /* TOPPERS_MPF_T */
typedef	TOPPERS_MPF_T	MPF_T;	/* Œ蒷v[̈mۂ邽߂̌^ */

/*
 *  bZ[Wwb_̌^`
 */
typedef	struct t_msg {			/* [{bNX̃bZ[Wwb_ */
	struct t_msg	*pk_next;
} T_MSG;

typedef	struct t_msg_pri {		/* DxtbZ[Wwb_ */
	T_MSG	msgque;				/* bZ[Wwb_ */
	PRI		msgpri;				/* bZ[WDx */
} T_MSG_PRI;

/*
 *  pPbg`̒`
 */
typedef struct t_rtsk {
	STAT	tskstat;	/* ^XN */
	PRI		tskpri;		/* ^XŇݗDx */
	PRI		tskbpri;	/* ^XÑx[XDx */
	STAT	tskwait;	/* ҂v */
	ID		wobjid;		/* ҂Ώۂ̃IuWFNgID */
	TMO		lefttmo;	/* ^CAEg܂ł̎ */
	uint_t	actcnt;		/* NvL[CO */
	uint_t	wupcnt;		/* NvL[CO */
	bool_t	texmsk;		/* ^XNO}XNԂۂ */
	bool_t	waifbd;		/* ҂֎~Ԃۂ */
	uint_t	svclevel;	/* gT[rXR[̃lXgx */
} T_RTSK;

typedef struct t_rtex {
	STAT	texstat;	/* ^XNȌ */
	TEXPTN	pndptn;		/* ۗOv */
} T_RTEX;

typedef struct t_rsem {
	ID		wtskid;		/* Z}tH̑҂s̐擪̃^XNIDԍ */
	uint_t	semcnt;		/* Z}tȞ݂̎ */
} T_RSEM;

typedef struct t_rflg {
	ID		wtskid;		/* CxgtȎ҂s̐擪̃^XNIDԍ */
	FLGPTN	flgptn;		/* CxgtǑ݂̃rbgp^[ */
} T_RFLG;

typedef struct t_rdtq {
	ID		stskid;		/* f[^L[̑M҂s̐擪̃^XNIDԍ */
	ID		rtskid;		/* f[^L[̎M҂s̐擪̃^XNIDԍ */
	uint_t	sdtqcnt;	/* f[^L[Ǘ̈Ɋi[Ăf[^̐ */
} T_RDTQ;

typedef struct t_rpdq {
	ID		stskid;		/* Dxf[^L[̑M҂s̐擪̃^XN
						   IDԍ */
	ID		rtskid;		/* Dxf[^L[̎M҂s̐擪̃^XN
						   IDԍ */
	uint_t	spdqcnt;	/* Dxf[^L[Ǘ̈Ɋi[Ăf[
						   ^̐ */
} T_RPDQ;

typedef struct t_rmtx {
	ID		htskid;		/* ~[ebNXbNĂ^XNIDԍ */
	ID		wtskid;		/* ~[ebNX̑҂s̐擪̃^XNIDԍ */
} T_RMTX;

typedef struct t_rmpf {
	ID		wtskid;		/* Œ蒷v[̑҂s̐擪̃^XN
						   IDԍ */
	uint_t	fblkcnt;	/* Œ蒷v[̈̋󂫃̈Ɋ
						   t邱ƂłŒ蒷ubN̐ */
} T_RMPF;

typedef struct t_rcyc {
	STAT	cycstat;	/* nh̓ */
	RELTIM	lefttim;	/* ɎnhN鎞܂ł̑Ύ */
} T_RCYC;

typedef struct t_ralm {
	STAT	almstat;	/* A[nh̓ */
	RELTIM	lefttim;	/* A[nhN鎞܂ł̑Ύ */
} T_RALM;

typedef struct t_rovr {
	STAT	ovrstat;	/* I[onh̓ */
	OVRTIM	leftotm;	/* cvZbT */
} T_ROVR;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  T[rXR[ďô߂̒`Ɛ錾
 */
#include <kernel_fncode.h>				/* @\R[h̒` */
#include "target_svc.h"					/* \tgEFA݂ɂďo */
#include <svc_call.h>					/* ֐ďoɂďo */

#define SVC_CALL(svc)	_kernel_##svc	/* ֐ďoɂĂяo */

/*
 *  IuWFNg̒`
 */
#define TA_ACT			UINT_C(0x02)	/* ^XNNꂽԂŐ */

#define TA_TPRI			UINT_C(0x01)	/* ^XN̑҂sDx */
#define TA_MPRI			UINT_C(0x02)	/* bZ[WL[Dx */

#define TA_WMUL			UINT_C(0x02)	/* ̑҂^XN */
#define TA_CLR			UINT_C(0x04)	/* CxgtÕNAw */

#define TA_CEILING		UINT_C(0x03)	/* DxvgR */

#define TA_STA			UINT_C(0x02)	/* nh𓮍ԂŐ */

#define	TA_NOWRITE		UINT_C(0x01)	/* ݃ANZX֎~ */
#define	TA_NOREAD		UINT_C(0x02)	/* ǏoANZX֎~ */
#define	TA_EXEC			UINT_C(0x04)	/* sANZX */
#define	TA_MEMINI		UINT_C(0x08)	/* ̏s */
#define	TA_MEMPRSV		UINT_C(0x10)	/* ̏sȂ */
#define	TA_SDATA		UINT_C(0x20)	/* V[gf[^̈ɔzu */
#define	TA_UNCACHE		UINT_C(0x40)	/* LbVs */
#define	TA_IODEV		UINT_C(0x80)	/* ӃfoCẌ̗ */

#define	TA_STDROM		UINT_C(0x02)	/* WROM[W */
#define	TA_STDRAM		UINT_C(0x04)	/* WRAM[W */

#define TA_NONKERNEL	UINT_C(0x02)	/* J[lǗO̊ */

#define TA_ENAINT		UINT_C(0x01)	/* ݗv֎~tONA */
#define TA_EDGE			UINT_C(0x02)	/* GbWgK */

/*
 *  T[rXR[̓샂[h̒`
 */
#define TWF_ORW			UINT_C(0x01)	/* CxgtOOR҂ */
#define TWF_ANDW		UINT_C(0x02)	/* CxgtOAND҂ */

#define	TPM_WRITE		UINT_C(0x01)	/* ݃ANZX̃`FbN */
#define	TPM_READ		UINT_C(0x02)	/* ǏoANZX̃`FbN */
#define	TPM_EXEC		UINT_C(0x04)	/* sANZX̃`FbN */

/*
 *  IuWFNg̏Ԃ̒`
 */
#define TTS_RUN			UINT_C(0x01)	/* s */
#define TTS_RDY			UINT_C(0x02)	/* s\ */
#define TTS_WAI			UINT_C(0x04)	/* ҂ */
#define TTS_SUS			UINT_C(0x08)	/* ҂ */
#define TTS_WAS			UINT_C(0x0c)	/* d҂ */
#define TTS_DMT			UINT_C(0x10)	/* x~ */

#define TTW_SLP			UINT_C(0x0001)	/* N҂ */
#define TTW_DLY			UINT_C(0x0002)	/* Ԍoߑ҂ */
#define TTW_SEM			UINT_C(0x0004)	/* Z}tH̎l҂ */
#define TTW_FLG			UINT_C(0x0008)	/* CxgtO҂ */
#define TTW_SDTQ		UINT_C(0x0010)	/* f[^L[ւ̑M҂ */
#define TTW_RDTQ		UINT_C(0x0020)	/* f[^L[̎M҂ */
#define TTW_SPDQ		UINT_C(0x0100)	/* Dxf[^L[ւ̑M҂ */
#define TTW_RPDQ		UINT_C(0x0200)	/* Dxf[^L[̎M҂ */
#define TTW_MTX			UINT_C(0x0080)	/* ~[ebNX̃bN҂ */
#define TTW_MPF			UINT_C(0x2000)	/* Œ蒷ubN̊l҂ */

#define TTEX_ENA		UINT_C(0x01)	/* ^XNO */
#define TTEX_DIS		UINT_C(0x02)	/* ^XNO֎~ */

#define TCYC_STP		UINT_C(0x01)	/* nh삵ĂȂ */
#define TCYC_STA		UINT_C(0x02)	/* nh삵Ă */

#define TALM_STP		UINT_C(0x01)	/* A[nh삵ĂȂ */
#define TALM_STA		UINT_C(0x02)	/* A[nh삵Ă */

#define TOVR_STP		UINT_C(0x01)	/* I[onh삵ĂȂ*/
#define TOVR_STA		UINT_C(0x02)	/* I[onh삵Ă */

/*
 *  یhCID
 */
#define TDOM_SELF		0				/* ^XN̑یhC */
#define TDOM_KERNEL		(-1)			/* J[lhC */
#define TDOM_NONE		(-2)			/* iیhCɑȂj*/

/*
 *  ̑̒萔̒`
 */
#define TSK_SELF		0			/* ^XNw */
#define TSK_NONE		0			/* Y^XNȂ */

#define TPRI_SELF		0			/* ^XÑx[XDx */
#define TPRI_INI		0			/* ^XN̋NDx */

#define TIPM_ENAALL		0			/* ݗDx}XNS */

/*
 *  \萔ƃ}N
 */

/*
 *  T|[g@\
 */
#ifdef TOPPERS_TARGET_SUPPORT_DIS_INT
#define TOPPERS_SUPPORT_DIS_INT			/* dis_intT|[gĂ */
#endif /* TOPPERS_TARGET_SUPPORT_DIS_INT */

#ifdef TOPPERS_TARGET_SUPPORT_ENA_INT
#define TOPPERS_SUPPORT_ENA_INT			/* ena_intT|[gĂ */
#endif /* TOPPERS_TARGET_SUPPORT_ENA_INT */

#ifdef TOPPERS_TARGET_SUPPORT_GET_UTM
#define TOPPERS_SUPPORT_GET_UTM			/* get_utmT|[gĂ */
#endif /* TOPPERS_TARGET_SUPPORT_GET_UTM */

#define TOPPERS_SUPPORT_MUTEX			/* ~[ebNX@\g */

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
#define TOPPERS_SUPPORT_OVRHDR			/* I[onh@\g */
#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#define TOPPERS_SUPPORT_PROTECT			/* ی@\Ή̃J[l */

#ifdef TOPPERS_TARGET_SUPPORT_ATT_MOD
#define TOPPERS_SUPPORT_ATT_MOD			/* ATT_MODT|[gĂ */
#endif /* TOPPERS_TARGET_SUPPORT_ATT_MOD */

#ifdef TOPPERS_TARGET_SUPPORT_ATT_PMA
#define TOPPERS_SUPPORT_ATT_PMA			/* ATT_PMAT|[gĂ */
#endif /* TOPPERS_TARGET_SUPPORT_ATT_PMA */

/*
 *  Dx͈̔
 */
#define TMIN_TPRI		1			/* ^XNDx̍ŏliōlj*/
#define TMAX_TPRI		16			/* ^XNDx̍őliŒlj*/
#define TMIN_DPRI		1			/* f[^Dx̍ŏliōlj*/
#define TMAX_DPRI		16			/* f[^Dx̍őliŒlj*/
#define TMIN_MPRI		1			/* bZ[WDx̍ŏliōlj*/
#define TMAX_MPRI		16			/* bZ[WDx̍őliŒlj*/
#define TMIN_ISRPRI		1			/* ݃T[rX[`Dx̍ŏl */
#define TMAX_ISRPRI		16			/* ݃T[rX[`Dx̍ől */

/*
 *  o[W
 */
#define TKERNEL_MAKER	UINT_C(0x0118)	/* J[l̃[J[R[h */
#define TKERNEL_PRID	UINT_C(0x0006)	/* J[l̎ʔԍ */
#define TKERNEL_SPVER	UINT_C(0xf514)	/* J[ldl̃o[Wԍ */
#define TKERNEL_PRVER	UINT_C(0x2000)	/* J[l̃o[Wԍ */

/*
 *  L[CO񐔂̍ől
 */
#define TMAX_ACTCNT		UINT_C(1)		/* NvL[CO̍ől */
#define TMAX_WUPCNT		UINT_C(1)		/* NvL[CO̍ől */

/*
 *  rbgp^[̃rbg
 */
#ifndef TBIT_TEXPTN					/* ^XNOṽrbg */
#define TBIT_TEXPTN		(sizeof(TEXPTN) * CHAR_BIT)
#endif /* TBIT_TEXPTN */

#ifndef TBIT_FLGPTN					/* CxgtÕrbg */
#define TBIT_FLGPTN		(sizeof(FLGPTN) * CHAR_BIT)
#endif /* TBIT_FLGPTN */

/*
 *  vZbTԁiOVRTIMj̍ől
 */
#ifndef TMAX_OVRTIM
#define TMAX_OVRTIM		ULONG_MAX
#endif /* TMAX_OVRTIM */

/*
 *  ̈mۂ̂߂̃}N
 *
 *  ȉTOPPERS_COUNT_SZTOPPERS_ROUND_SZ̒`́Cunit2̋Џł
 *  邱Ƃ肵ĂD
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - 1) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - 1) & ~((unit) - 1))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		TOPPERS_COUNT_SZ(sz, sizeof(STK_T))
#define ROUND_STK_T(sz)		TOPPERS_ROUND_SZ(sz, sizeof(STK_T))

#define COUNT_MPF_T(blksz)	TOPPERS_COUNT_SZ(blksz, sizeof(MPF_T))
#define ROUND_MPF_T(blksz)	TOPPERS_ROUND_SZ(blksz, sizeof(MPF_T))

/*
 *  ̑̍\萔
 */
#define TMAX_MAXSEM		UINT_MAX	/* Z}tH̍ő厑̍ől */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_KERNEL_H */
