/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: memory.c 599 2012-02-05 06:40:30Z ertl-hiro $
 */

/*
 *		IuWFNgǗW[
 */

#include "kernel_impl.h"
#include "task.h"
#include "memory.h"

/*
 *  IuWFNgǗW[̏
 */
#ifdef TOPPERS_memini
#ifndef OMIT_INITIALIZE_MEMORY

void
initialize_memory(void)
{
}

#endif /* OMIT_INITIALIZE_MEMORY */
#endif /* TOPPERS_memini */

/*
 *  IuWFNgubŇ
 */
#ifdef TOPPERS_memsearch
#ifndef OMIT_STANDARD_MEMINIB

int_t
search_meminib(const void *addr)
{
	uint_t	left, right, i;

	left = 0;
	right = tnum_meminib - 1;
	while (left < right) {
		i = (left + right + 1) / 2;
		if ((SIZE)(addr) < (SIZE)(memtop_table[i])) {
			right = i - 1;
		}
		else {
			left = i;
		}
	}
	return(left);
}

#endif /* OMIT_STANDARD_MEMINIB */
#endif /* TOPPERS_memsearch */

/*
 *  ւ̏݌̃`FbN
 */
#ifdef TOPPERS_memprbw
#ifndef OMIT_PROBE_MEM_WRITE

bool_t
probe_mem_write(const void *base, SIZE size)
{
	int_t	meminib;
	ATR		mematr;
	SIZE	memsize;

	meminib = search_meminib(base);
	mematr = meminib_table[meminib].mematr;
	memsize = ((char *)((meminib + 1 < tnum_meminib) ?
					memtop_table[meminib + 1] : 0)) - ((char *) base);

	if (mematr == TA_NULL) {
		return(false);
	}
	else if (size > memsize) {
		/*
		 *  w肳ꂽ̈悪C̃IuWFNgɂ܂
		 *  Ăꍇ
		 */
		return(false);
	}
	else if ((mematr & TOPPERS_USTACK) == 0U) {
		/*
		 *  ((mematr & TA_NOWRITE) != 0U)̎́Cacptn10ɂĂ邽
		 *  ߁C҂̃`FbN݂̂s΂悢D
		 */
		return((rundom & meminib_table[meminib].acptn1) != 0U);
	}
	else {
		return(within_ustack(base, size, p_runtsk));
	}
}

#endif /* OMIT_PROBE_MEM_WRITE */
#endif /* TOPPERS_memprbw */

/*
 *  ̓Ǐõ`FbN
 */
#ifdef TOPPERS_memprbr
#ifndef OMIT_PROBE_MEM_READ

bool_t
probe_mem_read(const void *base, SIZE size)
{
	int_t	meminib;
	ATR		mematr;
	SIZE	memsize;

	meminib = search_meminib(base);
	mematr = meminib_table[meminib].mematr;
	memsize = ((char *)((meminib + 1 < tnum_meminib) ?
					memtop_table[meminib + 1] : 0)) - ((char *) base);

	if (mematr == TA_NULL) {
		return(false);
	}
	else if (size > memsize) {
		/*
		 *  w肳ꂽ̈悪C̃IuWFNgɂ܂
		 *  Ăꍇ
		 */
		return(false);
	}
	else if ((mematr & TOPPERS_USTACK) == 0U) {
		return((mematr & TA_NOREAD) == 0U
					&& (rundom & meminib_table[meminib].acptn2) != 0U);
	}
	else {
		return(within_ustack(base, size, p_runtsk));
	}
	return(true);
}

#endif /* OMIT_PROBE_MEM_READ */
#endif /* TOPPERS_memprbr */

/*
 *  X^bN̈Ɋ܂܂Ă邩̃`FbN
 */
#ifdef TOPPERS_memprbs
#ifndef OMIT_PROBE_STACK

bool_t
probe_stack(const void *base, SIZE size)
{
	return(within_ustack(base, size, p_runtsk));
}

#endif /* OMIT_PROBE_STACK */
#endif /* TOPPERS_memprbs */

/*
 *  DATAZNVBSSZNV̏
 */
#ifdef TOPPERS_secini
#ifndef OMIT_INITIALIZE_SECTIONS

void
initialize_sections(void)
{
	uint_t				i;
	uint8_t				*src, *dst;
	const DATASECINIB	*p_datasecinib;
	const BSSSECINIB	*p_bsssecinib;

	for (i = 0; i < tnum_datasec; i++) {
		p_datasecinib = &(datasecinib_table[i]);
		for (src = p_datasecinib->start_idata, dst = p_datasecinib->start_data;
				(SIZE)(dst) < (SIZE)(p_datasecinib->end_data); src++, dst++) {
					
			*dst = *src;
		}
	}
	for (i = 0; i < tnum_bsssec; i++) {
		p_bsssecinib = &(bsssecinib_table[i]);
		for (dst = p_bsssecinib->start_bss;
				(SIZE)(dst) < (SIZE)(p_bsssecinib->end_bss); dst++) {
			*dst = 0U;
		}
	}
}

#endif /* OMIT_INITIALIZE_SECTIONS */
#endif /* TOPPERS_secini */
