/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: memory.h 599 2012-02-05 06:40:30Z ertl-hiro $
 */

/*
 *		IuWFNgǗW[
 */

#ifndef TOPPERS_MEMORY_H
#define TOPPERS_MEMORY_H

/*
 *  iJ[lŗpj
 *
 *  HRP2J[lŎۂɎQƂĂ̂́CTOPPERS_USTACK݂̂łD
 *  ̑2́CJ[lł͋ʂĈKvȂD
 *
 *  RtBM[^tŒ蒷v[̈́C̃
 *  IuWFNgƓꍇ邽߁CTOPPERS_ATTSEC̃
 *  ƂD
 */
#define TOPPERS_ATTSEC	0x0100	/* ATT_SEC^ATA_SEC܂ATT_MOD^ATA_MOD
								   œo^ꂽIuWFNg */
#define TOPPERS_ATTMEM	0x0200	/* ATT_MEM^ATA_MEMœo^ꂽIu
								   WFNg */
#define TOPPERS_USTACK	0x0400	/* ^XÑ[UX^bN̈ */

#ifndef TOPPERS_MACRO_ONLY
#ifndef OMIT_STANDARD_MEMINIB

/*
 *  IuWFNgubN
 *
 *  gp̈iTA_NULLjɑ΂ẮCׂẴANZXp^[
 *  iacptn1Cacptn2Cacptn4j0ɂD܂C[hI[iTA_ROj
 *  ̗̈ɑ΂ẮCʏ푀1i݃ANZXj̃ANZXp^[
 *  iacptn1j0ɂD
 */
typedef struct memory_initialization_block {
	ATR		mematr;			/* IuWFNg */
	ACPTN	acptn4;			/* QƑ̃ANZXp^[ */
	ACPTN	acptn1;			/* ʏ푀1̃ANZXp^[^^XNTCB */
	ACPTN	acptn2;			/* ʏ푀2̃ANZXp^[ */
} MEMINIB;

/*
 *  RtBM[^IuWFNgubN𐶐ꍇ
 *
 *  IuWFNgubÑGgCIuWFNg
 *  擪Ԓn̗̈CIuWFNgubN̗̈́CC
 *  RtBM[^kernel_cfg.cɒ萔̈ƂĐD
 */

/*
 *  IuWFNgubÑGgikernel_cfg.cj
 */
extern const uint_t		tnum_meminib;

/*
 *  IuWFNg̐擪Ԓn̗̈ikernel_cfg.cj
 */
extern void *const		memtop_table[];

/*
 *  IuWFNgubN̗̈ikernel_cfg.cj
 */
extern const MEMINIB	meminib_table[];

#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  IuWFNgǗW[̏
 */
extern void		initialize_memory(void);

/*
 *  IuWFNgubŇ
 *
 *  IuWFNgubNCaddr܂ރIuWFNg
 *  C̃CfbNXԂD
 */
#ifndef OMIT_STANDARD_MEMINIB

extern int_t	search_meminib(const void *addr);

#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  ̈悪IuWFNgɊ܂܂Ă邩̃`FbN
 *
 *  擪ԒnbaseŃTCYsizẽ̈悪C擪ԒnmobaseŃTC
 *  YmosizẽIuWFNgɊ܂܂ĂꍇtrueCłȂ
 *  ꍇfalseԂD
 */
Inline bool_t
within_memobj(const void *base, SIZE size, void *mobase, SIZE mosize)
{
	return((SIZE)(mobase) <= (SIZE)(base) && size <= mosize
			&& (SIZE)((char *)(base) - (char *)(mobase)) <= mosize - size);
}

/*
 *  ̈悪[UX^bN̈Ɋ܂܂Ă邩̃`FbN
 *
 *  擪ԒnbaseŃTCYsizẽ̈悪Cp_tcbŎw肳^XN
 *  ̃[UX^bN̈Ɋ܂܂ĂꍇtrueCłȂꍇ
 *  falseԂD
 */
#ifndef USE_TSKINICTXB

Inline bool_t
within_ustack(const void *base, SIZE size, TCB *p_tcb)
{
	return(within_memobj(base, size,
					p_tcb->p_tinib->ustk, p_tcb->p_tinib->ustksz));
}

#else /* USE_TSKINICTXB */

extern bool_t	within_ustack(const void *base, SIZE size, TCB *p_tcb);

#endif /* USE_TSKINICTXB */

/*
 *  ւ̏݌̃`FbN
 *
 *  s̕یhCi[UhCjCw肵̈ւ̏
 *  ݌Ă邩`FbNC݌ĂꍇtrueC
 *  łȂꍇfalseԂDs̕یhCJ[lhC
 *  ̎́C̊֐Ăł͂ȂȂD
 */
extern bool_t	probe_mem_write(const void *base, SIZE size);

/*
 *  ̓Ǐõ`FbN
 *
 *  s̕یhCi[UhCjCw肵̈ւ̓
 *  oĂ邩`FbNCǏoĂꍇtrueC
 *  łȂꍇfalseԂDs̕یhCJ[lhC
 *  ̎́C̊֐Ăł͂ȂȂD
 */
extern bool_t	probe_mem_read(const void *base, SIZE size);

/*
 *  X^bN̈Ɋ܂܂Ă邩̃`FbN
 *
 *  w肵̈悪C^XÑX^bN̈Ɋ܂܂Ă邩ǂ
 *  `FbNC܂܂ĂꍇtrueCłȂꍇfalseԂD
 */
extern bool_t	probe_stack(const void *base, SIZE size);

/*
 *  ANZX̃`FbN̂߂̃}N
 *
 *  ȉ̒`́CACg̒Pʂ2̋Џł邱Ƃ肵ĂD
 */
#ifndef PROBE_MEM_WRITE
#define PROBE_MEM_WRITE(p_var, type) \
				(ALIGN_TYPE(p_var, type) && (rundom == TACP_KERNEL \
					|| probe_mem_write((void *)(p_var), sizeof(*(p_var)))))
#endif /* PROBE_MEM_WRITE */

#ifndef PROBE_MEM_READ
#define PROBE_MEM_READ(p_var, type) \
				(ALIGN_TYPE(p_var, type) && (rundom == TACP_KERNEL \
					|| probe_mem_read((void *)(p_var), sizeof(*(p_var)))))
#endif /* PROBE_MEM_READ */

/*
 *  X^bNւ̃ANZX`FbN̂߂̃}N
 */
#ifndef PROBE_STACK
#define PROBE_STACK(sp, size) \
				(ALIGN_TYPE(sp, STK_T) && probe_stack(sp, size))
#endif /* PROBE_STACK */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  dataZNVubN
 */
typedef struct {
	void	*start_data;		/* dataZNV̐擪Ԓn */
	void	*end_data;			/* dataZNV̏IԒn */
	void	*start_idata;		/* f[^̈̐擪Ԓn */
} DATASECINIB;

/*
 *  dataZNV̐ƏubÑGAikernel_cfg.cj
 */
extern const uint_t	tnum_datasec;
extern const DATASECINIB	datasecinib_table[];

/*
 *  bssZNVubN
 */
typedef struct {
	void	*start_bss;			/* bssZNV̐擪Ԓn */
	void	*end_bss;			/* bssZNV̏IԒn */
} BSSSECINIB;

/*
 *  bssZNV̐ƏubÑGAikernel_cfg.cj
 */
extern const uint_t	tnum_bsssec;
extern const BSSSECINIB	bsssecinib_table[];

#endif /* TOPPERS_MEMORY_H */
