/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2011 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sh_scif.h 2227 2011-08-09 09:24:29Z mit-kimai $
 */

/*
 *   SH SCIFp ȈSIOhCo
 *   @
 *   @A[LeN`ˑɒuɁApdic/shfBNgɒuĂ
 *   @̂́Ash1/2ash3/4aŋL邽
 */

#ifndef TOPPERS_SH_SCIF_H
#define TOPPERS_SH_SCIF_H

#ifndef TOPPERS_MACRO_ONLY

#include <kernel.h>	/*  INTNO  */

/*
 *  VAI/O|[gǗubN̒`
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_RDY_SND    1U        /* M\R[obN */
#define SIO_RDY_RCV    2U        /* MʒmR[obN */

/*
 *  SIOhCȍ[`
 */
extern void sh_scif_initialize(void);

/*
 * J[lÑo[io͗p̏
 */
extern void sh_scif_init(ID siopid);

/*
 *  VAI/O|[gւ̃|[Oł̏o
 */
extern void sh_scif_pol_putc(char c, ID siopid);

/*
 *  I[vĂ|[g邩H
 */
extern bool_t sh_scif_openflag_id(ID siopid);	/*  |[gID  */
												/*  ǗubN̐擪Ԓn  */
extern bool_t sh_scif_openflag_cb(const SIOPCB *p_siopcb);

/* 
 *  |[gID̎擾 
 */ 
extern ID sh_scif_get_siopid(const SIOPCB *p_siopcb);

/*
 *  VAI/O|[g̃I[v
 */
extern SIOPCB *sh_scif_opn_por(ID siopid, intptr_t exinf);

/*
 *  VAI/O|[g̃N[Y
 */
extern void sh_scif_cls_por(SIOPCB *p_siopcb);

/*
 *  VAI/O|[gւ̕M
 */
extern bool_t sh_scif_snd_chr(const SIOPCB *p_siopcb, char c);

/*
 *  VAI/O|[g̕M
 */
extern int_t sh_scif_rcv_chr(const SIOPCB *p_siopcb);

/*
 *  VAI/O|[g̃R[obN̋
 */
extern void  sh_scif_ena_cbr(const SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
extern void sh_scif_dis_cbr(const SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  SIO̊݃T[rX[`
 */
extern void sh_scif_tx_isr(ID siopid);
extern void sh_scif_rx_isr(ID siopid);

/*
 *  VAI/O|[g̑M\R[obN
 */
extern void sh_scif_irdy_snd(intptr_t exinf);

/*
 *  VAI/O|[g̎MʒmR[obN
 */
extern void sh_scif_irdy_rcv(intptr_t exinf);


/*
 *  |[gԍǗubN̐擪Ԓnւ̕ϊ
 */
extern SIOPCB *sh_scif_get_siopcb(ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_SH_SCIF_H */
