/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: logtask.h 334 2010-08-23 04:24:54Z ertl-hiro $
 */

/*
 *		VXeO^XN
 */

#ifndef TOPPERS_LOGTASK_H
#define TOPPERS_LOGTASK_H

#ifdef __cplusplus
extern "C" {
#endif

#include "target_syssvc.h"
#include <extsvc_fncode.h>

/*
 *  VXeO^XN֘A̒萔̃ftHgl̒`
 */ 
#ifndef LOGTASK_PRIORITY
#define LOGTASK_PRIORITY	3		/* Dx */
#endif /* LOGTASK_PRIORITY */

#ifndef LOGTASK_STACK_SIZE
#define LOGTASK_STACK_SIZE	1024	/* X^bN̈̃TCY */
#endif /* LOGTASK_STACK_SIZE */

#ifndef LOGTASK_PORTID
#define LOGTASK_PORTID		1		/* VXeOp̃VA|[gԍ */
#endif /* LOGTASK_PORTID */

#ifndef LOGTASK_INTERVAL
#define LOGTASK_INTERVAL	10U		/* VXeO^XN̓Ԋui~bj*/
#endif /* LOGTASK_INTERVAL */

#ifndef LOGTASK_FLUSH_WAIT
#define LOGTASK_FLUSH_WAIT	1U		/* tbV҂̒Pʎԁi~bj*/
#endif /* LOGTASK_FLUSH_WAIT */

/*
 *  VXeO^XN̖{
 */
extern void	logtask_main(intptr_t exinf) throw();

/*
 *  VXeO^XN̏I
 */
extern void	logtask_terminate(intptr_t exinf) throw();

/*
 *  VXeO^XN̊gT[rXR[ɂďoC^tF[X
 */
#ifndef TOPPERS_SVC_CALL

/*
 *  VXeOo͂̑҂킹
 *
 *  Oobt@̃O̐countȉɂȂ܂ő҂Dcount0̏ꍇ
 *  ́CVAobt@ɂȂ̂҂D
 */
Inline ER
logtask_flush(uint_t count)
{
	return((ER) cal_svc(TFN_LOGTASK_FLUSH, (intptr_t) count, 0, 0, 0, 0));
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  VXeO^XN̊֐ďoɂďoC^tF[X
 */
extern ER	_logtask_logtask_flush(uint_t count) throw();

#ifdef TOPPERS_SVC_CALL
#define logtask_flush	_logtask_logtask_flush
#endif /* TOPPERS_SVC_CALL */

/*
 *  VXeO^XNgT[rXR[Ƃēo^邽߂̒`
 */
extern ER_UINT	extsvc_logtask_flush(intptr_t count, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_LOGTASK_H */
