/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  $Id: serial.h 581 2012-01-15 09:13:27Z ertl-hiro $
 */

/*
 *		VAC^tF[XhCo
 */

#ifndef TOPPERS_SERIAL_H
#define TOPPERS_SERIAL_H

#ifdef __cplusplus
extern "C" {
#endif

#include <extsvc_fncode.h>

/*
 *  VAC^tF[XhCo̗ppPbg
 */
typedef struct {
	uint_t		reacnt;			/* Mobt@̕ */
	uint_t		wricnt;			/* Mobt@̕ */
} T_SERIAL_RPOR;

/*
 *  VAC^tF[XhCȍ[`
 */
extern void		serial_initialize(intptr_t exinf) throw();

/*
 *  VAC^tF[XhCo̖M̎o
 */
extern bool_t	serial_get_chr(ID portid, char *p_c) throw();

/*
 *  VAC^tF[XhCo̊gT[rXR[ɂďoC
 *  ^tF[X
 */
#ifndef TOPPERS_SVC_CALL

Inline ER
serial_opn_por(ID portid)
{
	return((ER) cal_svc(TFN_SERIAL_OPN_POR, (intptr_t) portid, 0, 0, 0, 0));
}

Inline ER
serial_cls_por(ID portid)
{
	return((ER) cal_svc(TFN_SERIAL_CLS_POR, (intptr_t) portid, 0, 0, 0, 0));
}

Inline ER_UINT
serial_rea_dat(ID portid, char *buf, uint_t len)
{
	return(cal_svc(TFN_SERIAL_REA_DAT, (intptr_t) portid, (intptr_t) buf,
													(intptr_t) len, 0, 0));
}

Inline ER_UINT
serial_wri_dat(ID portid, const char *buf, uint_t len)
{
	return(cal_svc(TFN_SERIAL_WRI_DAT, (intptr_t) portid, (intptr_t) buf,
													(intptr_t) len, 0, 0));
}

Inline ER
serial_ctl_por(ID portid, uint_t ioctl)
{
	return((ER) cal_svc(TFN_SERIAL_CTL_POR, (intptr_t) portid,
												(intptr_t) ioctl, 0, 0, 0));
}

Inline ER
serial_ref_por(ID portid, T_SERIAL_RPOR *pk_rpor)
{
	return((ER) cal_svc(TFN_SERIAL_REF_POR, (intptr_t) portid,
											(intptr_t) pk_rpor, 0, 0, 0));
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  VAC^tF[XhCo̊֐ďoɂďoC^tF[
 *  X
 */
extern ER		_serial_serial_opn_por(ID portid) throw();
extern ER		_serial_serial_cls_por(ID portid) throw();
extern ER_UINT	_serial_serial_rea_dat(ID portid, char *buf,
													uint_t len) throw();
extern ER_UINT	_serial_serial_wri_dat(ID portid, const char *buf,
													uint_t len) throw();
extern ER		_serial_serial_ctl_por(ID portid, uint_t ioctl) throw();
extern ER		_serial_serial_ref_por(ID portid,
										T_SERIAL_RPOR *pk_rpor) throw();

#ifdef TOPPERS_SVC_CALL
#define serial_opn_por	_serial_serial_opn_por
#define serial_cls_por	_serial_serial_cls_por
#define serial_rea_dat	_serial_serial_rea_dat
#define serial_wri_dat	_serial_serial_wri_dat
#define serial_ctl_por	_serial_serial_ctl_por
#define serial_ref_por	_serial_serial_ref_por
#endif /* TOPPERS_SVC_CALL */

/*
 *  VAC^tF[XhCogT[rXR[Ƃēo^邽
 *  ߂̒`
 */
extern ER_UINT	extsvc_serial_opn_por(intptr_t portid, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_cls_por(intptr_t portid, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_rea_dat(intptr_t portid, intptr_t buf,
									intptr_t len, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_wri_dat(intptr_t portid, intptr_t buf,
									intptr_t len, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_ctl_por(intptr_t portid, intptr_t ioctl,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_serial_ref_por(intptr_t portid, intptr_t pk_rpor,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

/*
 *  VAC^tF[XhCo̓쐧p̂߂̒萔
 *
 *  ȉ̒萔́Crbgɘ_aƂėpD
 */
#define	IOCTL_NULL	0U			/* wȂ */
#define	IOCTL_ECHO	0x0001U		/* MGR[obN */
#define	IOCTL_CRLF	0x0010U		/* LF𑗐MOCRt */
#define	IOCTL_FCSND	0x0100U		/* Mɑ΂ăt[s */
#define	IOCTL_FCANY	0x0200U		/* ǂ̂悤ȕłMĊJ */
#define	IOCTL_FCRCV	0x0400U		/* Mɑ΂ăt[s */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_SERIAL_H */
