/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  $Id: syslog.h 524 2011-09-27 06:40:20Z ertl-hiro $
 */

/*
 *		VXeO@\
 */

#ifndef TOPPERS_SYSLOG_H
#define TOPPERS_SYSLOG_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  VXeOo͂s߂̒`
 */
#include <t_syslog.h>
#include <extsvc_fncode.h>

/*
 *  Oobt@ƂɃANZX邽߂̃|C^
 */
#ifndef TCNT_SYSLOG_BUFFER
#define TCNT_SYSLOG_BUFFER	32		/* Oobt@̃TCY */
#endif /* TCNT_SYSLOG_BUFFER */

/*
 *  VXeO@\̏
 */
extern void	syslog_initialize(intptr_t exinf) throw();

/*
 *  VXeO@\̊gT[rXR[ɂďoC^tF[X
 */
#ifndef TOPPERS_SVC_CALL

/*
 *  Ȍo
 *
 *  TOPPERS_OMIT_SYSLOG`ĂȂꍇCsyslog_wri_log
 *  t_syslog.hŒ`邽߂ɁCł͒`ȂD
 */
#ifdef TOPPERS_OMIT_SYSLOG

Inline ER
syslog_wri_log(uint_t prio, const SYSLOG *p_syslog)
{
	return((ER) cal_svc(TFN_SYSLOG_WRI_LOG, (intptr_t) prio,
										(intptr_t) p_syslog, 0, 0, 0));
}

#endif /* TOPPERS_OMIT_SYSLOG */

/*
 *  Oobt@̃O̓Ǐo
 */
Inline ER_UINT
syslog_rea_log(SYSLOG *p_syslog)
{
	return(cal_svc(TFN_SYSLOG_REA_LOG, (intptr_t) p_syslog, 0, 0, 0, 0));
}

/* 
 *  oׂ͂Ȍdvx̐ݒ
 */
Inline ER_UINT
syslog_msk_log(intptr_t logmask, intptr_t lowmask)
{
	return(cal_svc(TFN_SYSLOG_MSK_LOG, (intptr_t) logmask,
											(intptr_t) lowmask, 0, 0, 0));
}

/* 
 *  Oobt@̏ԎQ
 */
Inline ER_UINT
syslog_ref_log(intptr_t pk_rlog)
{
	return(cal_svc(TFN_SYSLOG_REF_LOG, (intptr_t) pk_rlog, 0, 0, 0, 0));
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  VXeO@\̊֐ďoɂďoC^tF[X
 */
extern ER		_syslog_syslog_wri_log(uint_t prio,
										const SYSLOG *p_syslog) throw();
extern ER_UINT	_syslog_syslog_rea_log(SYSLOG *p_syslog) throw();
extern ER		_syslog_syslog_msk_log(uint_t logmask, uint_t lowmask) throw();
extern ER		_syslog_syslog_ref_log(T_SYSLOG_RLOG *pk_rlog) throw();

#ifdef TOPPERS_SVC_CALL
#define syslog_wri_log	_syslog_syslog_wri_log
#define syslog_rea_log	_syslog_syslog_rea_log
#define syslog_msk_log	_syslog_syslog_msk_log
#define syslog_ref_log	_syslog_syslog_ref_log
#endif /* TOPPERS_SVC_CALL */

/*
 *  VXeO@\gT[rXR[Ƃēo^邽߂̒`
 */
extern ER_UINT	extsvc_syslog_wri_log(intptr_t prio, intptr_t p_syslog,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_rea_log(intptr_t p_syslog, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_msk_log(intptr_t logmask, intptr_t lowmask,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_ref_log(intptr_t pk_rlog, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_SYSLOG_H */
