/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel  
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: soisoc.h 893 2013-04-24 04:19:03Z nces-mtakada $
 */

/*
 *  SOI-SOC CPU{[ĥ̃n[hEFA̒`
 */

#ifndef TOPPERS_SOISOC_H
#define TOPPERS_SOISOC_H

#include <sil.h>

/*
 *  vZbT̃n[hEFA̒`̃CN[h
 */
#include "sh34_shc/sh7750r.h"

/*
 *  ӃNbN P = 30MHz
 */
#define	PCLOCK			30000000

/*
 *  DDR擪AhX
 */
#define	DDR_BASE_ADDR	0x0c000000

/*
 *  DDR֘ÃWX^
 */
#define DDR_DMWR_B	0xfe800604		/* dummy write for big endian */
#define DDR_DMWR_L	0xfe800600		/* dummy write for little endian */
#define DDR_SDMR1	0xFEC02000		/* EMRS reg : DLL enable - BA0:1,A1=A0=0 */
#define DDR_SDMR2	0xFEC00b08		/* MRS  reg : BurtsLength=2,BurstSequence=Sequencial,CL=2.5,DLL=reset */
#define DDR_SDMR3	0xFEC00308		/* MRS  reg : BurtsLength=2,BurstSequence=Sequencial,CL=2.5,DLL=mormal */

#define DDRIF_MIM_H	0xFE800008		/* DDRIF MIM register */
#define DDRIF_MIM_L	0xFE80000c		/* DDRIF MIM register */
#define DDRIF_SDR_H	0xFE800030		/* DDRIF SDR register */
#define DDRIF_SDR_L	0xFE800034		/* DDRIF SDR register */
#define DDRIF_STR_H	0xFE800018		/* DDRIF STR register */
#define DDRIF_STR_L	0xFE80001c		/* DDRIF STR register */
#define DDRIF_SCR_H	0xFE800010		/* DDRIF SCR register */
#define DDRIF_SCR_L	0xFE800014		/* DDRIF SCR register */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  Jˑ̏
 */
Inline void
soisoc_exit(void)
{
    uint32_t sr = 0x10000000U;
    
    /*
     * IɃZbg𔭐
     */
    /*
     * BLrbg𗧂Ă
     */
    set_cr( sr );
    
    /*
     * ݗO
     */
    *((volatile int *) 0xFFFFFEC1U) = 0;
} 
#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_SOISOC_H */
