/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/* 
 * TOPPERS/HRP2SOISOCpLbV֐
 * LbV֐̂P2̈̐pZNVɔzuBitext_cachej
 * J[l^XNŎgpꍇ͂̂܂܎gp邱Ƃł邪A
 * [U^XN痘pꍇ͊gT[rXR[gpB
 * gT[rXR[̂܂܎gpƎg肪̂
 * [U^XN̊֐񋟂Bi֐ut́j
 *
 * OSNɂ̓LbVOFFłB
 * ȉ̊֐́Aenable_cache()săf[^LbVA߃LbVON
 * ɂĂgpĉB
 */

#pragma section cache

#include "target_cache.h"
#include <machine.h>

/* LbVWX^ */
#define CACHE (*(volatile unsigned int*)0xFF00001C) /* CACHE Address*/

#define	OC_address	(volatile unsigned int *)0xF4000000
#define	IC_address	(volatile unsigned int *)0xF0000000
#define	OC_SIZE		(512)
#define	IC_SIZE		(256)
#define P2_ADDR		(0xA0000000)
#define P3_ADDR		(0xC0000000)
#define P4_ADDR		(0xE0000000)

int IsCacheArea(void *pStart, void *pEnd);

void OcacheOFF( void )
{
	unsigned int *pAry = OC_address;
	int	len = OC_SIZE;
	int i;
	
	/* LbV{[hȂ */
	if ((CACHE & 0x80000000) != 0) {
		len = OC_SIZE * 2;
	}
	/* OCache Flash */
	for (i = 0; i < len; i++) {
		*pAry = 0;
		pAry += 8;
	}
	CACHE |= 0x0008;	/* OCI(OCrbg)Zbg */
	CACHE &= (~0x0021);	/* OCE, ORA bit𗎂Ƃ*/

	/* CACHEݒnop8񕪈ȏWait */
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
}

void OcacheON(WT_MODE mode)
{
	unsigned int ccr;
	unsigned int val;
	
	ccr = CACHE;

	/* IyhLbVLRs[obN[h? */
	if ((ccr & 0x05) == 0x05) {
		if (mode == COPY_BACK) {
			/* 󂩂ωȂ̂ŏI */
			return;
		} else {
			//cal_svc( OOFF_SVC, 0, 0, 0, 0, 0 );
            OcacheOFF();
		}
	} else {
		ccr &= (~0x0021);		/* OCE, ORA bit𗎂Ƃ*/
		ccr |= 0x0008;			/* OCI(OCrbg)Zbg */
		CACHE = ccr;
	}
	
	ccr = CACHE;
	ccr &= (~0x0007);		/* CB, WT bit𗎂Ƃ*/
	CACHE = ccr;
	
	/* [hyOCErbgݒ */
	if (mode == COPY_BACK) {
		val = 0x0005;		/* CB|OCE */
	} else {
		val = 0x0003;		/* WT|OCE */
	}
	CACHE |= val;

	/* CACHEݒnop8񕪈ȏWait */
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
}

void IcacheOFF(void)
{
	unsigned int *pAry = IC_address;
	int	len = IC_SIZE;
	int	i;
	
	if ((CACHE & 0x80000000) != 0) {
		len = IC_SIZE * 2;
	}
	for (i = 0; i < len; i++) {
		*pAry = 0;
		pAry += 8;
	}
	CACHE |= 0x0800;		/* ICI(ICrbg)Zbg */
	CACHE &= (~0x0100);		/* ICE bit𗎂Ƃ */

	/* CACHEݒnop8񕪈ȏWait */
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
}

void IcacheON(void)
{
	unsigned int ccr;

	ccr = CACHE;
	ccr &= (~0x0100);
	ccr |= 0x0800;
	CACHE = ccr;
	CACHE |= 0x0100;
	
	/* CACHEݒnop8񕪈ȏWait */
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
	nop();
}

/* 	
 *	wAhX͈͂̃f[^f[^LbVɃqbgꍇɏ߂
 *	LbV͗L̂܂
 */
void OcacheWriteBack(void *pStart, void *pEnd)
{
	int *p, *q;
	unsigned int ccr;

	if (IsCacheArea(pStart, pEnd)) {
		
		ccr = CACHE;
	
		/* IyhLbVLRs[obN[hȂ珑߂ */
		if ((ccr & 0x05) == 0x05) {
		
		    p = (int *)((unsigned long)pStart & 0xffffffe0);
		    q = (int *)((unsigned long)pEnd & 0xffffffe0);

			for (; p <= q; p+= 8) {
				ocbwb(p);
			}
		}
	}
}

/* 	
 *	wAhX͈͂̃f[^LbVɃqbgꍇɏ߂ɖɂ
 */
void OcacheInvalid(void *pStart, void *pEnd)
{
	int *p, *q;
	unsigned int ccr;

	if (IsCacheArea(pStart, pEnd)) {
	
		ccr = CACHE;

		/* OCache Enable */ 
		if (ccr & 0x01) {
	
		    p = (int *)((unsigned long)pStart & 0xffffffe0);
		    q = (int *)((unsigned long)pEnd & 0xffffffe0);

			/* ŏ̃ubN̓p[W */
			ocbp(p);
			p += 8;
			if (q >= p)
			{
				/* Ō̃ubNp[W */
				ocbp(q);
				q -= 8;
			}
			/* c𖳌 */
			for (; p <= q; p += 8) {
				ocbi(p);
			}
		}
	}	
}


/*
 *	w͈͂LbVO\GA肷B
 *	߂l@0:GAO, 1:GA
 */
int IsCacheArea(void *pStart, void *pEnd)
{
	int iret = 0;
	
	/* JnAhX <= IAhX */
	if ((unsigned int)pStart <= (unsigned int)pEnd) {

		/* w͈͂LbVO\GA */
		if (((unsigned int)pEnd < P2_ADDR) ||
			(((unsigned int)pStart >= P3_ADDR) && ((unsigned int)pEnd < P4_ADDR))) {
			iret = 1;
		}
	}
	return iret;
}


/* ȍ~[U^XNĂяoꍇ̊gT[rXR[ */
/* X̊֐̓J[lĂԂ߂ɎcĂ̂Œp */
ER_UINT OcacheOFFs(intptr_t par1, intptr_t par2, intptr_t par3, intptr_t par4, intptr_t par5, ID cdmid)
{
    OcacheOFF();
    return 0;
}

ER_UINT OcacheONs(intptr_t par1, intptr_t par2, intptr_t par3, intptr_t par4, intptr_t par5, ID cdmid)
{
    OcacheON( par1 );
    return 0;
}

ER_UINT IcacheOFFs(intptr_t par1, intptr_t par2, intptr_t par3, intptr_t par4, intptr_t par5, ID cdmid)
{
    IcacheOFF();
    return 0;
}

ER_UINT IcacheONs(intptr_t par1, intptr_t par2, intptr_t par3, intptr_t par4, intptr_t par5, ID cdmid)
{
    IcacheON();
    return 0;
}


/* ȍ~[Ũbv֐ */
/* gT[rXR[Ăł */
#pragma section shared

void OcacheOFFu( void )
{
    cal_svc( OOFF_SVC, 0, 0, 0, 0, 0 );
    return;
}

void OcacheONu(WT_MODE mode)
{
    cal_svc( OON_SVC, mode, 0, 0, 0, 0 );
    return;
}

void IcacheOFFu(void)
{
    cal_svc( IOFF_SVC, 0, 0, 0, 0, 0 );
    return;
}

void IcacheONu(void)
{
    cal_svc( ION_SVC, 0, 0, 0, 0, 0 );
    return;
}
