/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_config.c 894 2013-04-24 07:53:45Z nces-mtakada $
 */

/*
 *  ^[QbgˑW[iSOI-SOCpj
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "soisoc.h"
#include "task.h"
#include "memory.h"

#include "target_cache.h"

#ifdef ROM_BOOT
uint32_t __dummy = 1;
#endif

/*
 *  ^[Qbgˑ̏
 */
void
target_initialize(void)
{
    /*
     *  vZbTˑ̏
     */
    prc_initialize();

    target_mmu_initialize();

    /*
     * o[i[o͗p̃VARg[̏
     */
    sh_scif_init(TARGET_PUTC_PORTID);    
}

/*
 *  ^[Qbgˑ̏I
 */
void
target_exit(void)
{
    /*
     *  vZbTˑ̏I
     */
    prc_terminate();

    /*
     *  Jˑ̏I
     */
    //soisoc_exit();
    
    IcacheOFF();
    OcacheOFF();

    /*
     * ɂ͗Ȃ
     */
    while(1);
}

/*
 *  VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log(char c)
{
    #ifdef TOPPERS_HEW_SIMULATOR
    if (c == '\n') {
        charput('\r');
    }
    charput(c);
    #else /* TOPPERS_HEW_SIMULATOR */
    if (c == '\n') {
        sh_scif_pol_putc('\r', TARGET_PUTC_PORTID);
    }
    sh_scif_pol_putc(c, TARGET_PUTC_PORTID);
    #endif /* TOPPERS_HEW_SIMULATOR */
}

/*
 *  ̈悪[UX^bN̈Ɋ܂܂Ă邩̃`FbN
 *
 *  擪ԒnbaseŃTCYsizẽ̈悪Cp_tcbŎw肳^XN
 *  ̃[UX^bN̈Ɋ܂܂ĂꍇtrueCłȂꍇ
 *  falseԂD
 *
 *  ̈̐擪Ԓn烆[UX^bN̒܂ł̒
 *  ̈̃TCY傫CC
 *  [UX^bÑTCY΁C̈́C
 *  [UX^bN͈͓̔łD
 *
 */
bool_t
within_ustack(const void *base, SIZE size, TCB *p_tcb)
{
    SIZE stk_bottom = (SIZE)(p_tcb->p_tinib->tskinictxb.stk_bottom);
    SIZE len = stk_bottom - (SIZE)base;

    return ((SIZE)base < stk_bottom
            && len >= size
            && len <= (SIZE)(p_tcb->p_tinib->tskinictxb.stksz));
}

/*
 *  [U^XÑ^XNOĂяoɎgpX^bNTCYȂH
 */
bool_t
i_check_tex_runtsk()
{
    SIZE ustk_top = (SIZE)(p_runtsk->tskctxb.usp);

    if(!PROBE_STACK((void *)(ustk_top - USRTEX_STKSZ), 
                USRTEX_STKSZ)){
        return (true);
    }

    return (false);
}  

