/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_config.h 476 2013-04-24 07:55:24Z mtakada $
 */

/*
 *  ^[QbgˑW[iSOI-SOCpj
 *
 *  J[l̃^[Qbgˑ̃CN[ht@CDkernel_impl.h̃^[
 *  Qbgˑ̈ʒutƂȂD
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  ^[QbgVXẽn[hEFA̒`
 */
#include "soisoc.h"

/*
 *  g[XOɊւݒ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#include "target_mmu.h"

/*
 *  ^[Qbgˑ̕o͂Ɏgp|[g̒`
 */
#define TARGET_PUTC_PORTID 1

/*
 *  HRPJ[l쎞̃}bvƊ֘A`
 *       
 *      0x8c000000 - 0x8cffffff R[ḧ(1MB)
 *      0x8c100000 -            f[^̈(3MB)
 *                 - 0x8c3fffff ^XNƗpX^bN
 *                 - 0x8e000000 I
 *
 */

/*
 *  ftHg̔^XNReLXgp̃X^bN̈̒`
 */
#define DEFAULT_ISTKSZ    0x2000U

/*
 *  LbV[h̐ݒ
 *    P1(0x8..)              : Rs[obN
 *    P0(0x0..),U0,P3(0x3..) : Rs[obN
 */
#define CCR_MODE    0x00000105

/*
 *  FPŨoNWX^ۑ邩̒`
 */
//#define FPU_SAVE_BANKED_REG

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ^[QbgVXeˑ̏
 */
extern void target_initialize(void);

/*
 *  ^[QbgVXȅI
 *
 *  VXeI鎞ɎgD
 */
extern void target_exit(void);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԑ҂̂߂̒`i{SIL̃^[Qbgˑj
 */
#define SIL_DLY_TIM1     46
#define SIL_DLY_TIM2     25

#ifndef TOPPERS_MACRO_ONLY
// trapaOnh
extern void target_trapa_handler(void *p_excinf);

#define DEFAULT_SSTKSZ 2048 

/*
 *	^XNReLXgubN
 */
#define USE_TSKINICTXB	/*  TSKINICTXBgp  */

typedef struct task_initialization_context_block {
	SIZE	sstksz;			/* X^bN̈̃TCYiۂ߂lj */
	void	*sstk_bottom;	/* X^bN|C^̏liX^bN̒̏lj */
	SIZE	stksz;			/* X^bN̈̃TCYiۂ߂lj */
	void	*stk_bottom;	/* X^bN|C^̏liX^bN̒̏lj */
} TSKINICTXB;

/*
 *  یhCReLXgubN
 */

#define USE_DOMINICTXB	/*  TSKINICTXBgp  */

typedef struct {
    uint32_t asid;
    void *page_table_info;
} DOMINICTXB;

/*
 *  [U^XN[hsH
 *  priv_modéAT[rXR[AсAgT[rXR[
 *  trueɃZbg
 */
#define t_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define i_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define t_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)
#define i_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)

#define USRTEX_STKSZ 16

extern bool_t i_check_tex_runtsk();

#endif /* TOPPERS_MACRO_ONLY */

#define NO_SVC 1        /* T[rXR[Ăяotrapä */
#define NO_RET_TEX 2    /* ret_texĂяotrapä */

/*
 *  vZbTˑW[iSH34pj
 */
#include "sh34_shc/sh7750r_config.h"

#ifdef CHECK_FUNC_ALIGN
#undef CHECK_FUNC_ALIGN
#define CHECK_FUNC_ALIGN 2
#endif /* CHECK_FUNC_ALIGN */

#define USE_REDZONE 1   /* RED ZONE g */

#define TOPPERS_EMPTY_LABEL(x,y) x y[1] /* HEW pTOPPERS_EMPTY_LABEL */

#endif  /* TOPPERS_TARGET_CONFIG_H */
