/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *	Ai{\tgEFAς̂܂ށDȉjgpEE
 *	ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *		܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *		RɊÂCL쌠҂TOPPERSvWFNg
 *		Ɛӂ邱ƁD
 *	
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *	ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *	A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *	̐ӔC𕉂ȂD
 *	
 */

#ifndef _TOPPERS_TARGET_MEM_H_
#define _TOPPERS_TARGET_MEM_H_

/*
 *  [WɊւ`
 *  [U[hŃANZXł̈́C
 *  0x0000 0000 - 0x7FFF FFFF
 */
#ifdef ROM_BOOT

/*
 *  ROMu[g[h̏ꍇ
 *  texẗFLASHiGA0: 0x0000 0000 - 0x003F FFFFj
 *  datäSDRAMiGA3: 0x0C00 0000 - 0x0DFF FFFFj
 */
#define TEXT_START_ADDRESS 0x00000000
#define TEXT_REGION_SIZE   0x00400000
#define DATA_START_ADDRESS 0x0C000000
#define DATA_REGION_SIZE   0x02000000

#else /* ROM_BOOT */

/*
 *  RAMu[g[h̏ꍇ
 *  texẗdatä͋SDRAMiGA3: 0x0C00 0000 - 0x0DFF FFFFj
 *  texẗdatä͋SRAMiGA0: 0x0000 0000 - 0x0003 FFFFj
 */
#if 0 // SDRAMgp
#define TEXT_START_ADDRESS 0x0C000000
#define TEXT_REGION_SIZE   0x00100000
#define DATA_START_ADDRESS 0x0C100000
#define DATA_REGION_SIZE   0x01F00000
#else // SRAMgp
#define TEXT_START_ADDRESS 0x00000000
#define TEXT_REGION_SIZE   0x00100000
#define DATA_START_ADDRESS 0x04000000
#define DATA_REGION_SIZE   0x00200000
#endif

#endif /* ROM_BOOT */

#include "target_mmu.h"

#endif /* _TOPPERS_TARGET_MEM_H_ */

