/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *	Ai{\tgEFAς̂܂ށDȉjgpEE
 *	ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *		܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *		RɊÂCL쌠҂TOPPERSvWFNg
 *		Ɛӂ邱ƁD
 *	
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *	ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *	A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *	̐ӔC𕉂ȂD
 *	
 */

/*
 *	MMUhCoiSH7750Rpj
 */

#include "kernel_impl.h"
#include "task.h"
#include "memory.h"
#include <sil.h>
#include "kernel_cfg.h"
#include "target_mmu.h"

#include <machine.h>

extern char _vector_start;
extern char _vector_end;
extern char _vector_entry_start;
extern char _vector_entry_end;

// TLBیᔽOCf[^TLBیᔽiǏojO
void
target_rxtlb_violation_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "Memory access violation (rx) is occured.");
    while(1);
}

// f[^TLBیᔽi݁jO
void
target_wtlb_violation_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "Memory access violation (w) is occured.");
    while(1);
}

// y[WݗO
void
target_iwr_page_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "TLB entry's dirty bit is false.");
    while(1);
}

// ^XNOsJnX^bNsnh
void
target_emulate_texrtn_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at prepare texrtn.");
    while(1);
}

// ^XNO^[X^bNsnh
void
target_emulate_ret_tex_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at return texrtn.");
    while(1);
}

// [` 
void
target_mmu_initialize(void)
{
    /*
     *  ݂ASIDJ[lhCpi0jɃZbg
     */
    sil_wrw_mem((void *)(MMU_PTEH), (uint32_t)((TASID_KERNEL) << (MMU_PTEH_ASID_BIT)));

    /*
     *  y[We[ũx[XAhXmemtop_tableƂ
     */
    sil_wrw_mem((void *)(MMU_TTB), (uint32_t)(_kernel_memtop_table));

    /*
     *  MMU䃌WX^̐ݒ
     *  LRUI = 0: ͂߂ɓւITLBGg3
     *  URB = 0: ׂẴGgւ̑Ώ
     *  URC = 0: ւUTLBGg̃JEgl0ɏ
     *  SQMD = 1: XgAL[̈ւ̃ANZX͓[ĥ
     *  SV = 0: dzL[h
     *          ődzL[hƂ̂́CقȂhC
     *          ^XNɂTLBɍڂy[WCASID̃Gg
     *          [hŃANZX邱Ƃ邽߂ł
     *  TI = 1: TLBtbV
     *  AT = 1: MMULɂ
     */
    sil_wrw_mem((void *)(MMUCR), (uint32_t)(MMUCR_SQMD_PM | MMUCR_TI | MMUCR_AT));

    /*
     *  Ô߁C8ߕ҂
     */
    nop();
    nop();
    nop();
    nop();
    nop();
    nop();
    nop();
    nop();

    /*
     *  LbVp[W
     */
    //sil_wrw_mem((void *)(CCR), (uint32_t)(CCR_DISABLE));
    //sil_wrw_mem((void *)(CCR), (uint32_t)(CCR_MODE));

}

