/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *	Ai{\tgEFAς̂܂ށDȉjgpEE
 *	ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *		܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *		RɊÂCL쌠҂TOPPERSvWFNg
 *		Ɛӂ邱ƁD
 *	
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *	ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *	A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *	̐ӔC𕉂ȂD
 *	
 */

/*
 *	MMUhCoiSH7750Rpj
 */

#ifndef TOPPERS_TARGET_MMU_H
#define TOPPERS_TARGET_MMU_H

/*
 *  y[We[uGgʃWX^iPTEHj
 *  [VPN 31:10] - - [ASID 7:0]
 */
#define MMU_PTEH 0xff000000 /* y[We[uGgʃWX^ */
#define MMU_PTEH_VPN_MASK 0xfffffc00 /* zy[Wԍ̃}XN */
#define MMU_PTEH_VPN_BIT  10         /* zy[Wԍ̃rbgʒu */
#define MMU_PTEH_ASID_MASK 0x0000000f /* ASID̃}XN */
#define MMU_PTEH_ASID_BIT  0          /* ASID̃rbgʒu */

/*
 *  y[We[uGgʃWX^iPTELj
 *  - - - [PPN 28:10] - V SZ [PR 6:5] SZ C D SH WT
 */
#define MMU_PTEL 0xff000004 /* y[We[uGgʃWX^ */
#define MMU_PTEL_SH 0x00000002 /* Lԃrbg */
    /*
     *  0/1F̃vZXŃy[WLȂ/
     *  >> SH͋LhCȂ1ŁAȊOȂ0
     *  >> SH1ƁATLB̃AhXrASIDQƂȂ
     */
#define MMU_PTEL_SZ_1K  0x00000000 /* y[WTCYrbg:1K */
#define MMU_PTEL_SZ_4K  0x00000010 /* y[WTCYrbg:4K */
#define MMU_PTEL_SZ_64K 0x00000080 /* y[WTCYrbg:64K */
#define MMU_PTEL_SZ_1M  0x00000090 /* y[WTCYrbg:1M */
#define MMU_PTEL_V 0x00000080 /* Lrbg */
#define MMU_PTEL_PPN_MASK 0x1ffffe00 /* y[Wԍ̃}XN */
#define MMU_PTEL_PPN_BIT  10         /* y[Wԍ̃rbgʒu */
    /* 
     *  AhX̏22rbg
     *   Vmjɒ
     */
#define MMU_PTEL_PR_PRX     0x00000000 /* یL[f[^:[hRX */
#define MMU_PTEL_PR_PRWX    0x00000020 /* یL[f[^:[hRWX */
#define MMU_PTEL_PR_URX     0x00000040 /* یL[f[^:[U[hRX */
#define MMU_PTEL_PR_URWX    0x00000060 /* یL[f[^:[U[hRWX */
#define MMU_PTEL_C 0x00000008   /* LbVO\rbg */
#define MMU_PTEL_D 0x00000004   /* _[eBrbg */
#define MMU_PTEL_WT 0x00000001  /* CgX[rbg */

/*
 *  y[We[uGgAVX^XWX^iPTEAj
 *  [- 31:4] TC SA
 */
#define MMU_PTEA 0xff000034 /* y[We[uGgAVX^XWX^ */

/*
 *  ϊe[ux[XWX^iTTBj
 *  [TTB 31:0]
 *  y[We[ũx[XAhX
 */
#define MMU_TTB 0xff000008 /* ϊe[ux[XWX^ */

/*
 *  TLBOAhXWX^iTEAj
 *  [ADDR 31:0]
 *  MMUO^AhXG[O̔zAhX
 */
#define MMU_TEA 0xff00000c /* TLBOAhXWX^ */

/*
 *  MMU䃌WX^iMMUCRj
 *  [LRUI 31:26] - - [URB 23:18] - - [URC 15:10] SQMD SV [- 7:3] TI - AT
 *  MMUCȐ́AP1AP2̈ōs
 *  MMUCRXVAP0AP3AU0AXgAL[̈Ƀf[^ANZXƂ́A4ߊԂɋ
 *  MMUCRXVAP0AP3AU0̈ɕ򂷂Ƃ́A8ߊԂɋ
 */
#define MMUCR 0xff000010 /* MMU䃌WX^ */
#define MMUCR_SQMD_UM 0x00000000 /* XgAL[[hrbg: [U[hŃANZX\ */
#define MMUCR_SQMD_PM 0x00000200 /* XgAL[[hrbg: [hł̂݃ANZX\ */
#define MMUCR_SV 0x00000100 /* zL[h̐؂ւrbg */
    /* 
     *  0dzL[hA1PꉼzL[h
     *  SVύXƂ́ATI1
     */
#define MMUCR_TI 0x00000004 /* TLBrbgD1TLBtbV */
#define MMUCR_AT 0x00000001 /* AhXϊLrbg */
#define MMUCR_LRUI_MASK 0xfc000000 /* ւITLBGg̃}XN */
#define MMUCR_LRUI_BIT  26         /* ւITLBGg̃rbgʒu */
#define MMUCR_URB_MASK 0x00fc0000 /* ւUTLBGgẼ}XN */
#define MMUCR_URB_BIT  18         /* ւUTLBGgẼrbgʒu */
#define MMUCR_URC_MASK 0x0000fc00 /* ւUTLBGg̃}XN */
#define MMUCR_URC_BIT  10         /* ւUTLBGg̃rbgʒu */

/*
 *  Oԍ̒`
 */
// TLBیᔽOCf[^TLBیᔽiǏojO
#define EXCNO_RXTLB_PRT     0x0A0
// f[^TLBیᔽi݁jO
#define EXCNO_WTLB_PRT      0x0C0
// y[WݗO
#define EXCNO_IWR_PAGE      0x080
// ^XNOsJnX^bNsnh
#define EXCNO_EMU_TEXRTN    0x200
// ^XNO^[X^bNsnh
#define EXCNO_EMU_RET_TEX   0x220

/*
 *  ASIDϊ}N
 *  J[lhC: 0
 *  [UhC: hCID
 */
#define TASID_KERNEL 0
#define TASID(domid) domid

#ifndef TOPPERS_MACRO_ONLY
// TLB~XOCf[^TLB~XiǏojO
extern void target_rxtlb_miss_handler(void *p_excinf);
// TLBیᔽOCf[^TLBیᔽiǏojO
extern void target_rxtlb_violation_handler(void *p_excinf);
// f[^TLB~Xi݁jO
extern void target_wtlb_miss_handler(void *p_excinf);
// f[^TLBیᔽi݁jO
extern void target_wtlb_violation_handler(void *p_excinf);
// y[WݗO
extern void target_iwr_page_handler(void *p_excinf);
// [` 
extern void target_mmu_initialize(void);
// ^XNOsJnX^bNsnh
extern void target_emulate_texrtn_handler(void *p_excinf);
// ^XNO^[X^bNsnh
extern void target_emulate_ret_tex_handler(void *p_excinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_MMU_H */
