/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_serial.c 2123 2011-06-23 02:58:49Z ertl-honda $
 */

/*
 *  VAI/OfoCXiSIOjhCoiSOI-SOCpj
 *  SCIF gp 
 */

#include <kernel.h>
#include <t_syslog.h>
#include "target_serial.h"

static INTNO const intno_sio_tx[1] = { 
    SCIF_TXI_INTEVT
}; 

static INTNO const intno_sio_rx[1] = { 
    SCIF_RXI_INTEVT
}; 

/* 
 *  VAI/O|[gID犄ݔԍo߂̃}N 
 */ 
#define INDEX_SIOP(siopid)           ((uint_t)((siopid) - 1)) 
#define get_intno_sio_tx(siopid)     (intno_sio_tx[INDEX_SIOP(siopid)]) 
#define get_intno_sio_rx(siopid)     (intno_sio_rx[INDEX_SIOP(siopid)]) 

/*
 *  SIOhCȍ
 */
void
sio_initialize(intptr_t exinf)
{
    sh_scif_initialize();    
}

/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB    *p_siopcb;
    ER        ercd;

    /*
     *  VAI/O݂}XND
     */
    ercd = dis_int(get_intno_sio_tx(siopid));
    assert(ercd == E_OK);
    ercd = dis_int(get_intno_sio_rx(siopid));
    assert(ercd == E_OK);

    /*
     *  foCXˑ̃I[vD
     */
    p_siopcb = sh_scif_opn_por(siopid, exinf);

    /*
     *  VAI/Õ݂}XND
     */
    ercd = ena_int(get_intno_sio_tx(siopid));
    assert(ercd == E_OK);
    ercd = ena_int(get_intno_sio_rx(siopid));
    assert(ercd == E_OK);

    return(p_siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    ER ercd;
    ID siopid; 

    /* 
     *  VAI/O|[gID̎擾 
     */ 
    siopid = sh_scif_get_siopid(p_siopcb);

    /*
     *  foCXˑ̃N[YD
     */
    sh_scif_cls_por(p_siopcb);

    /*
     *  VAI/O݂}XND
     */
    ercd = dis_int(intno_sio_tx[siopid]);
    assert(ercd == E_OK);
    ercd = dis_int(intno_sio_rx[siopid]);
    assert(ercd == E_OK);
}

/*
 *  SIO̊݃nh
 */
void
sio_tx_isr(intptr_t exinf)
{
    sh_scif_tx_isr(1);
}

/*
 *  SIO̊݃nh
 */
void
sio_rx_isr(intptr_t exinf)
{
    sh_scif_rx_isr(1);
}

/*
 *  VAI/O|[gւ̕M
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char c)
{
    return(sh_scif_snd_chr(siopcb, c));
}

/*
 *  VAI/O|[g̕M
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
    return(sh_scif_rcv_chr(siopcb));
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    sh_scif_ena_cbr(siopcb, cbrtn);
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    sh_scif_dis_cbr(siopcb, cbrtn);
}

/*
 *  VAI/O|[g̑M\R[obN
 */
void
sh_scif_irdy_snd(intptr_t exinf)
{
    sio_irdy_snd(exinf);
}

/*
 *  VAI/O|[g̎MʒmR[obN
 */
void
sh_scif_irdy_rcv(intptr_t exinf)
{
    sio_irdy_rcv(exinf);
}
