/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *	Ai{\tgEFAς̂܂ށDȉjgpEE
 *	ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *		܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *		RɊÂCL쌠҂TOPPERSvWFNg
 *		Ɛӂ邱ƁD
 *	
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *	ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *	A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *	̐ӔC𕉂ȂD
 *	
 *  @(#) $Id: target_svc.h 476 2013-04-24 07:55:24Z mtakada $
 */

#ifndef TOPPERS_TARGET_SVC_H
#define TOPPERS_TARGET_SVC_H

#ifndef TOPPERS_MACRO_ONLY


/*
 *  J[l̃T[rXR[̃C^tF[X
 *
 *  XNb`WX^
 *    r1 : ֐R[h
 *    r4 - r7 : i4܂Łj
 *    r2 : 5
 *  ֐Ăяo(jsr)ŃT[rXR[Ăяo߁CPRۑ
 */
extern char _kernel_svc_entry;

extern int R0_SVC;
extern int R1_SVC;
extern int R2_SVC;
extern int R4_SVC;
extern int R5_SVC;
extern int R6_SVC;
extern int R7_SVC;

extern void CAL_SVC_0M_ASM(void);
extern void CAL_SVC_1M_ASM(void);
extern void CAL_SVC_2M_ASM(void);
extern void CAL_SVC_3M_ASM(void);
extern void CAL_SVC_4M_ASM(void);
extern void CAL_SVC_5M_ASM(void);

#define CAL_SVC_0M(TYPE, FNCD) \
    R1_SVC = (int)FNCD;\
    CAL_SVC_0M_ASM();\
	return R0_SVC

#define CAL_SVC_1M(TYPE, FNCD, TYPE1, PAR1) \
    R1_SVC = (int)FNCD;\
    R4_SVC = (int)PAR1;\
    CAL_SVC_1M_ASM();\
	return R0_SVC

#define CAL_SVC_2M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
    R1_SVC = (int)FNCD;\
    R4_SVC = (int)PAR1;\
    R5_SVC = (int)PAR2;\
    CAL_SVC_2M_ASM();\
	return R0_SVC

#define CAL_SVC_3M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3) \
    R1_SVC = (int)FNCD;\
    R4_SVC = (int)PAR1;\
    R5_SVC = (int)PAR2;\
    R6_SVC = (int)PAR3;\
    CAL_SVC_3M_ASM();\
	return R0_SVC

#define CAL_SVC_4M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
						TYPE3, PAR3, TYPE4, PAR4) \
    R1_SVC = (int)FNCD;\
    R4_SVC = (int)PAR1;\
    R5_SVC = (int)PAR2;\
    R6_SVC = (int)PAR3;\
    R7_SVC = (int)PAR4;\
    CAL_SVC_4M_ASM();\
	return R0_SVC

#define CAL_SVC_5M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, \
						TYPE3, PAR3, TYPE4, PAR4, TYPE5, PAR5) \
    R1_SVC = (int)FNCD;\
    R4_SVC = (int)PAR1;\
    R5_SVC = (int)PAR2;\
    R6_SVC = (int)PAR3;\
    R7_SVC = (int)PAR4;\
    R2_SVC = (int)PAR5;\
    CAL_SVC_5M_ASM();\
	return R0_SVC


#ifndef TOPPERS_SVC_CALL
#include "shc/tool_svc.h"
#endif /* TOPPERS_SVC_CALL */

Inline ER_UINT
cal_svc(FN fncd, intptr_t par1, intptr_t par2,
        intptr_t par3, intptr_t par4, intptr_t par5)
{
    if(fncd > 0){
        CAL_SVC_5M(FN, fncd, intptr_t, par1, intptr_t, par2, 
                intptr_t, par3, intptr_t, par4, intptr_t, par5);
    } else {
        return (E_RSFN);
    }
}

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_TARGET_SVC_H */

