/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_timer.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *  ^C}hCoiSH34pj
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
#ifdef TRACE_ENABLE
#endif /* TRACE_ENABLE */

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	I[o^C}̏
 *
 *	^C}D
 */
void
target_ovrtimer_initialize(intptr_t exinf)
{
	/*
	 *	^C}ݒ肷D
	 */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));  /* ^C}~ */

    /* ݒA荞݋ */
    sil_wrh_mem((void*)TMU_TCR1,(0x020 | TCR0_TPSC));
    
}

/*
 *	I[o^C}̏I
 *
 *	^C}̓ID
 */
void
target_ovrtimer_terminate(intptr_t exinf)
{
    /* ^C}~ */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));
    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR1,0);

}

/*
 *	I[o^C}̋N
 *
 *	^C}ND
 */
void
target_ovrtimer_start(OVRTIM ovrtim)
{
	CLOCK	 cyc = OVRTIMER_CLOCK(ovrtim) - 1;

    /*
     *  ^C}ݒ肵C^C}̓JnD
     */
    assert(cyc <= MAX_CLOCK);             /* ^C}l̃`FbN */

    sil_wrw_mem((void*)TMU_TCOR1, cyc); /* timer constantWX^Zbg */
    sil_wrw_mem((void*)TMU_TCNT1, cyc); /* JE^[Zbg */

    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

    /* ^C}1X^[g */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) | TMU_STR1));
}

/*
 *	I[o^C}̒~
 *
 *	^C}̓~D
 */
OVRTIM
target_ovrtimer_stop(void)
{
    OVRTIM rest;

    /* ^C}~ */
    sil_wrb_mem((void*)TMU_TSTR,
                (sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR1));
    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

	rest = (OVRTIM)sil_rew_mem((void*)TMU_TCNT1);

    if(rest < 0){
        return 1;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	I[o^C}̎c莞Ԃ̓Ǐo
 */
OVRTIM
target_ovrtimer_get_current(void)
{
    OVRTIM rest;

	rest = (OVRTIM)sil_rew_mem((void*)TMU_TCNT1);

    if(rest < 0){
        return 0;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	I[o^C}݃nh
 */
void
target_ovrtimer_handler(void)
{
    /* 荞ݗvNA */
    sil_wrh_mem((void*)TMU_TCR1,
                (sil_reh_mem((void*)TMU_TCR1) & ~TCR_UNF));

	i_begin_int(INTNO_OVRTIMER);
	call_ovrhdr();
	i_end_int(INTNO_OVRTIMER);
}

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

