/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_timer.h 698 2012-07-11 08:12:24Z nces-mtakada $
 */

/*
 *  ^C}hCoiSOI-SOCpj
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

/*
 *  ^C}l̓\ msec PʂƂ̕ϊ
 *  SOI-SOCł́APNbN30MHz
 *   /4,/16,/64/256 ̂ꂩI
 *  /4  : 7.500MHz tick 7500
 *  /16 : 1.875MHz tick 1875
 *  /64 : 0.469MHz tick  469(0.46875)
 *  /256: 0.117MHz tick  117(0.1171875)
 *
 *  /16 I
 */

#define TCR0_TPSC  0x0001

/*
 *  ^C}l̓\ƃ~bPʂƂ̕ϊ
 */
#define TIMER_CLOCK 1875

/*
 * vZbTˑŒ`
 */ 
#include "sh34_shc/prc_timer.h"

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *  TMU_CMT1gp
 */

/*
 *	^C}݃nho^̂߂̒萔
 */
#define INHNO_OVRTIMER 	TMU1_INTEVT   /* ݃nhԍ */
#define INTNO_OVRTIMER 	TMU1_INTEVT   /* ݔԍ */
#define INTPRI_OVRTIMER	(-7)		  /* ݗDx */
#define INTATR_OVRTIMER	0U			  /* ݑ */

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	^C}l̓\ƃ}CNbPʂƂ̕ϊ
 *	1sec̃NbNJEg
 */
#define OVRTIMER_CLOCK(usec) ((usec) * TIMER_CLOCK / 1000)
#define OVRTIMER_USEC(clock) ((clock) * 1000 / TIMER_CLOCK)

/*
 *	I[o^C}̏
 *
 *	^C}D
 */
extern void target_ovrtimer_initialize(intptr_t exinf);

/*
 *	I[o^C}̏I
 *
 *	^C}̓ID
 */
extern void target_ovrtimer_terminate(intptr_t exinf);

/*
 *	I[o^C}̋N
 *
 *	^C}ND
 */
extern void target_ovrtimer_start(OVRTIM ovrtim);

/*
 *	I[o^C}̒~
 *
 *	^C}̓~D
 */
extern OVRTIM target_ovrtimer_stop(void);

/*
 *	I[o^C}̌ݒl̓Ǐo
 */
extern OVRTIM target_ovrtimer_get_current(void);

/*
 *	I[o^C}݃nh
 */
extern void target_ovrtimer_handler(void);

/*
 *  I[onhN[`
 */
extern void	call_ovrhdr(void);

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TARGET_TIMER_H */
